\ Dcf77SdrC.fth Taqoz V2.8
\ uses code from https://forums.parallax.com/discussion/174531/taqoz-reloaded-2-8-better-readabilit
\ -named-local-variables#latest
\ CWE 30.11.24

!polls \ clear multitasking

IFDEF *Dcf77*
    1 cogstop
    oldorg org
    FORGET *Dcf77*  }

pub *Dcf77*    PRINT" Dcf77SdrC.fth" ;

0 bytes oldorg

44 value dacPin
46 value compPin
46 value adcPin

long goeResult
long goeCount


$0100 value sinTab#
$0040 value tablen#
2147483647 tablen# 2 / / value deltaW#

\ 40 ( kHz ) 65536 * 32768 200000 */ value ddsFreq# \ kHz f. 1 MHz: 65536 32768 200 */
\ 77_50 ( kHz ) 65536 * 32768 200_000_00 */ value ddsFreq# \ kHz f. 1 MHz: 65536 32768 200 */
77_490_00 value dcfFreq# ( Hz * 100 )
dcfFreq# 100 / 32768 2/ * 65536 2* 200_000_000 */ value ddsFreq# \ kHz f. 1 MHz: 6553

\ 77500 7750 / value cycles# \ 500 Hz update
775 value cycles#
775 cycles# / value nAvg# \ 77500 / 775 = 100 d.h. 10ms per avg

4 value minPulse#
16 value longPulse#

%1111_0001_0_101_1111 16 << \
cycles# + value ddsD#
\ page 31
\ mmmm dddd sppp p111:
\ mmmm=11111 goertzel mode
\ dddd=0001 output X0 on all 4 dac channels
\ s=0 sinc1 mode
\ pppp= input pin group pppp=1010 = 44/16 - 1
\ 111 =???


%0000_0100_011 9 << \ %x0xx_x1xxBase pin +2 is summed; 011 for length 64
\ %0000_0100_010 9 << \ %x0xx_x1xxBase pin +2 is summed; 010 for length 128
sinTab# + value ddsS#
\ https://docs.google.com/document/d/1gn6oaT5Ib7CytvlZHacmrSbVBJsD9t_-kmvjd7nUR6o/edit# page36


\ DAC and Comparator input Modes ##################################################################

{
Text from extend.fth
DAC Output Modes
DIR enables output, OUT enables ADC
%0000_0000_000_1010000000000_00_00000_0P_DAC_990R_3VDAC 990O, 3.3V peak, ADC 1x ? IN
%xxxx_xxxx_xxx_xxxxxDDDDDDDD_xx_xxxxx_x
DDDDDDDD = 8-bit DAC value
}


: dac8 ( value ) \ set mode 8 bit dac and output value 255=3.3V
   dacPin pin
   ( value ) 8<<
   %0000_0000_000_1010000000000_00_00000_0 \ DAC 990O, 3.3V peak, ADC 1x ? IN
   \ %0000_0000_000_1010100000000_00_00000_0\ DAC 600O, 2.0V peak, ADC 1x ? IN
   or wrpin
   L \ set pin low ==> enables output
;

: dacTest
   key drop
   begin
      255 for
         \ i .
         i dac8
      next
   key until
;

: comp8 ( threshold -- true/false ) \ 8 bit comparator
   compPin pin
   8<<
   %0000_0000_000_11000_00000000_00_00000_0 \ Level comparator ( with 1k5 output if enabled )
   or wrpin
   F \ set pin to float ==> disables output
   R \ read pin state as input
;

: compTest {: comp# } \ dacPin and compPin linked with wire
      255 for
         i dac8 \ output a voltage
         comp# comp8 . \ compare at compPin
      next
;

\ Goertzel Mode ######################################################################
\


: sinLut \ write table into LUT sin:cos:cos:sin
   tablen# for
      10 0   i deltaW# * QROTATE \ higher 16 bits with low amplitude
      \ crlf i . . .
      24 <<
      swap 16 << or

      127 0   i deltaW# * QROTATE \ lower 16 bits
      8 <<
      or

      or
      i sinTab# + LUT!
   next ;

code setDdsFreq '( freq )
      setxfrq a
      jmp #@DROP
end

: setDdsDac
   dacPin pin
   \ %AAAA_BBBB_FFF_MMMMMMMMMMMMM_TT_SSSSS_0
   cogid 8<< \ source for DAC output
   \ %0000_0000_000_1010000000000_00_00000_0 or \ DAC 990O, 3.3V peak, ADC 1x ? IN
   %0000_0000_000_1011000000000_00_00000_0 or \ DAC 124Ohm, 3.3V
   %0000_0000_000_0000000000000_01_00000_0 or \ p_channel
   wrpin
   L \ set pin low ==> enables output

;

: setGoeAdc
   adcPin pin
   \ %100011_0000000_00_00000_0 wrpin \ Gain 1
   \ %100100_0000000_00_00000_0 wrpin \ Gain 3.16
   \ %100101_0000000_00_00000_0 wrpin \ Gain 10
   \ %100110_0000000_00_00000_0 wrpin \ Gain 31
   %100111_0000000_00_00000_0 wrpin \ Gain 100
;

code goeAsm '( ddsS  ddsD -- angle length ) for first and single
   xcont a,b ' prerun
   xcont a,b ' start
   getxacc r2 ' to clear the accumulators: read cos, prepare s-field
   mov     r2,0 ' read sine
   xcont a,b ' wait and get result
   getxacc a ' read cos, prepare s-field
   mov     b,0 ' read sine
   qvector a,b
   getqx   a
   getqy   b
   ret
end


code nextGoeAsm '( ddsS  ddsD -- angle length ) for following
   xcont a,b ' wait and get result
   getxacc a ' read cos, prepare s-field for. next. command
   mov     b,0 ' read sine
   qvector a,b
   getqx   a
   getqy   b
   ret
end


: doGoe ( -- length angle ) \ set up and do Goertzel once
   sinLut \ fill LUT Table
   ddsFreq# setDdsFreq
   \ setDdsDac
   setGoeAdc
   ddsS# ddsD# goeAsm
;

: doNextGoe ( -- length angle )
   ddsS# ddsD# nextGoeAsm
;


: testGoeSingle
   key drop
   begin
      crlf
      0
      4 for \ average
         doGoe swap drop
         +
      next
      4 /
      cycles# / . \ 360 $7fff_ffff */ .
      1000 ms
   key until
;

: testNextGoe
   key drop
   doGoe 2drop \ set up
   begin
      crlf
      0
      4 for \ average
         doNextGoe swap drop
         +
      next
      4 /
      cycles# / . \ 360 $7fff_ffff */ .
      1000 ms
   key until
;

long slowMid
long fastMid
long slowMax
long fastMax
long fallMid

: storeMax {: value# address# filter# }
   value# address# @ > if
      value# address# !
   else
      filter# address# +!
   then
; forgetLocals


: goeCog.old \ to be run in a second cog, will update goeResult
   getLutCode
   toInit
   doGoe 2drop \ set up
   0 goeCount !
   begin
      0
      nAvg# for \ average
         doNextGoe swap drop
         +
      next
      nAvg# /
      cycles# /
      dup 1000 *
      dup slowMid @ 500 * + 501 / slowMid !
      dup fastMid @ 20 * + 21 / fastMid !
      dup slowMax -10 storeMax
      fastMax -3000 storeMax
      dup goeResult !
      slowMax @ 56 100_000 */ < if fallMid ++ else fallMid ~ then
      \ fastMid @ slowMid @ < if fallMid ++ else fallMid ~ then
      goeCount ++
      \ 15 ms
   again
;

0 value phase#

: correctFreq
   phase# 0 > if
      phase# $1FFF_FFFF >
      \ if 1 else -1 then +to dcfFreq#
      if 77485_00 else 77495_00 then
   else
      dcfFreq#
   then
   dup 100 / 32768 2/ *
      65536 2* 200_000_000 */ to ddsFreq#
   ddsFreq# setDdsFreq

   dcfFreq# 99 * + 100 / to dcfFreq#
;

: goeCog \ to be run in a second cog, will update goeResult
   getLutCode
   toInit
   doGoe 2drop \ set up
   0 goeCount !
   begin
      doNextGoe swap to phase#
      cycles# /
      dup 1000 *
      dup slowMid @ 500 * + 501 / slowMid !
      dup fastMid @ 20 * + 21 / fastMid !
      dup slowMax -10 storeMax
      fastMax -3000 storeMax
      dup goeResult !
      slowMax @ 18 28_000 */ < if fallMid ++ else fallMid ~ then
      \ fastMid @ slowMid @ < if fallMid ++ else fallMid ~ then
      correctFreq
      goeCount ++
   again
;

' goeCog 1 run \ run in cog1

pub Display ;


100 value maxPlt#
0 value minPlt#
0 value oldAdj#

: pltYC ( Y Code -- )
   swap
   0 maxs
   \ 128 maxPlt# */
   128 slowMax @ 1000 / */
   128 mins
   15 +
   74
   %savePos
   %XY
   emit
   %restorePos
;

: plt ( value. -- )
   \ 100 - 0 maxs 100 mins spaces '*' emit ;
   getms 500 / oldAdj# <> if
      getms 500 / to oldAdj#
      -1 +to maxPlt#
      1 +to minPlt#
   then
   dup maxPlt# maxs to maxPlt#
   dup minPlt# mins to minPlt#
   0 maxs
   \ 100 maxPlt# */ spaces '*' emit ;
   '*' pltYC
;



0 value startMs#

: tG \ testGoeCog
   10 to maxPlt#
   10000 to minPlt#
   key drop
   getms to startMs#
   begin
      goeCount @
      crlf
      fastMid @ 1000 / 'f' pltYC
      slowMid @ 1000 / 's' pltYC
      slowMax @ 1000 / 'S' pltYC
      fastMax @ 1000 / 'F' pltYC
      getms startMs# - .
      goeCount @ .
      fallMid @ dup minPulse# > if %green %pen then .
      fallMid @ dup longPulse# > if %red %pen then .
      minPlt# .
      \ maxPlt# .
      slowMax @ 1000 / .
      phase# .
      dcfFreq# .AS" ##.###,## "
      goeResult @ dup . '*' pltYC
      %plain
      \ goeResult @ .
      begin
         dup
      goeCount @ <> until
      drop
   key until
;

: factors {: num# -- }
   num# for
      num# i / i * num# = if i . then
   next
; forgetLocals

pub Decoder ; \ ################################################

long secCnt
long dcfTime

: dcfDecode \ long pulse, output format hh.mm.ss like time@
    secCnt @ SWITCH
    21 CASE  100 dcfTime +! BREAK \ 1 minute
    22 CASE  200 dcfTime +! BREAK
    23 CASE  400 dcfTime +! BREAK
    24 CASE  800 dcfTime +! BREAK
    25 CASE 1000 dcfTime +! BREAK
    26 CASE 2000 dcfTime +! BREAK
    27 CASE 4000 dcfTime +! BREAK

    29 CASE  10000 dcfTime +! BREAK \ 1 hour
    30 CASE  20000 dcfTime +! BREAK
    31 CASE  40000 dcfTime +! BREAK
    32 CASE  80000 dcfTime +! BREAK
    33 CASE 100000 dcfTime +! BREAK
    34 CASE 200000 dcfTime +! BREAK
;

{
: dcfOntime ( -- )
    BEGIN 3 PIN@ 0 = UNTIL
    waitLH
        8 HIGH
        time @
        DUP lastLowHigh# @ - lowtime# !
        lastLowHigh# !
    waitHL
        8 LOW
        time @
        DUP lastLowHigh# @ - hightime# !
        lastHighLow# !
;
}

long lowtime
long hightime
long lastLowHigh
long lastHighLow
long lasttime
long lastUpdateS

: dcfPulseTime ( -- )
    BEGIN fallMid @ 0 = UNTIL
    BEGIN fallMid @ minPulse# > UNTIL
        getms
        DUP lastLowHigh @ - lowtime ! \ cycletime
        lastLowHigh !
    BEGIN fallMid @ 0 = UNTIL
        getms
        DUP lastLowHigh @ - hightime !
        lastHighLow !
;


: dcfGetBits
    lowtime @ 1500 > IF \ Minute completed
        0 secCnt !
    ELSE
        hightime  @ 20 > IF
            secCnt ++
            hightime  @   longPulse# minPulse# - 10 * > IF dcfDecode THEN
            \ fallMid @ longPulse# > if dcfDecode then
        THEN
    THEN
;


: dcfSetTime \ Set the software clock of Tachyon after 2 consecutive receptions
    secCnt @ 1 = IF
        lasttime  @ 100 + dcfTime @ = IF
            dcfTime @ time!
            0 lastLowHigh  !
            0 lastHighLow  !
            time@ lastUpdateS  !
            \ 10 ms CR green PEN ." Time Set "
        THEN
        dcfTime @ lasttime  !
        0 dcfTime !
    THEN
;


: dS \ dcfShow \ For debugging
    KEY DROP
    BEGIN
        dcfPulseTime
        dcfGetBits
        crlf secCnt @ DUP 1 = IF CR %red %PEN THEN
        time@ . lastUpdateS @ . lasttime  @ . . lowtime  @ . hightime  @ . dcfTime @ .
        dcfSetTime
        %plain
    KEY UNTIL
;


: dcfLoop \ Task for a separate cog
    BEGIN
        dcfPulseTime
        dcfGetBits
        dcfSetTime

    AGAIN
;

\ ' dcfLoop 4 RUN

: .dcf
    KEY DROP
    BEGIN
        1000 ms
        CR TIME@ . getms 1000 / lastUpdateS  @ -
        . lasttime  @ . dcfTime @ .
    KEY UNTIL ;

